require("util")
require("screen")
require("button")
require("animbutton")
require("image")
require("uianim")
require("spinner")
require("numericspinner")
require("screens/popupdialog")
require "textbutton"
require "widgets/toggle"
require("screens/keyscreen")

local spinner_atlas = "images/ui.xml"

local spinner_images = {
	arrow_normal = "spin_arrow.tex",
	arrow_over = "spin_arrow_over.tex",
	arrow_disabled = "spin_arrow_disabled.tex",
	bgtexture = "spinner.tex"
}

local text_font = DEFAULTFONT

local enableDisableOptions = { { text = "NO", data = false }, { text = "YES", data = true } }

local entityOptions = {
	{text = "Abigail", data = "abigail"},
	{text = "Baby Beefalo ", data = "babybeefalo"},
	{text = "Bat", data = "bat"}, -- E
	{text = "Bee", data = "bee"},
	{text = "Beefalo", data = "beefalo"},
	{text = "Blue Hound", data = "icehound"},
	{text = "Butterfly", data = "butterfly"},
	{text = "Chester", data = "chester"},
	{text = "Clockwork Bishop", data = "bishop"},
	{text = "Clockwork Knight", data = "knight"},
	{text = "Crawling Horror", data = "crawlinghorror"},
	{text = "Crow", data = "crow"},
	{text = "Deerclops", data = "deerclops"},
	{text = "Eyeplant", data = "eyeplant"},-- E
	{text = "Fire Hound", data = "firehound"},
	{text = "Frog", data = "frog"},
	{text = "Ghost", data = "ghost"},
	{text = "Gobbler", data = "perd"},
	{text = "Hound", data = "hound"},
	{text = "Killer Bee", data = "killerbee"},
	{text = "Krampus", data = "krampus"},
	{text = "MacTusk", data = "walrus"},
	{text = "Mandrake", data = "mandrake"},
	{text = "Merm", data = "merm"},
	{text = "Monkey", data = "monkey"},-- E
	{text = "Monkeybarrel", data = "monkeybarrel"},-- E
	{text = "Mosquito", data = "mosquito"},
	{text = "Penguin", data = "penguin"},-- E
	{text = "Pig Guard", data = "pigguard"},
	{text = "Pig King", data = "pigking"},
	{text = "Pig Man", data = "pigman"},
	{text = "Rabbit", data = "rabbit"},
	{text = "Robin", data = "robin"},
	{text = "Rocky", data = "rocky"},-- E
	{text = "Shadow Skittish", data = "shadowskittish"},
	{text = "Slurtle", data = "slurtle"}, -- E
	{text = "Smallbird", data = "smallbird"},
	{text = "Spider ", data = "spider"},
	{text = "Spider Queen", data = "spiderqueen"},
	{text = "Spider Warrior ", data = "spider_warrior"},
	{text = "Spider Hider", data = "spider_hider"}, -- E
	{text = "Spider Spitter", data = "spider_spitter"}, -- E
	{text = "Summer Koalefant", data = "koalefant_summer"},
	{text = "Tallbird", data = "tallbird"},
	{text = "Teenbird", data = "teenbird"},
	{text = "Tentacle", data = "tentacle"},
	{text = "Terrorbeak", data = "terrorbeak"},
	{text = "Tentacle pillar arm", data = "tentacle_pillar_arm"},-- E
	{text = "Treeguard", data = "leif"},
	{text = "Waxwell", data = "waxwell"},
	{text = "Wee MacTusk", data = "little_walrus"},
	{text = "W. Koalefant", data = "koalefant_winter"},
	{text = "W. Robin", data = "robin_winter"},
}

local uncraftableItemOptions = { 
	{text = "Ash", data = "ash"},
	{text = "Bat Bat", data = "batbat"}, -- I
	{text = "Beard Hair", data = "beardhair"},
	{text = "Bee", data = "bee"},
	{text = "Beefalo Horn", data = "horn"},
	{text = "Beefalo Wool", data = "beefalowool"},
	{text = "Blue Gem", data = "bluegem"},
	{text = "Bunny Tail", data = "manrabbit_tail"}, -- I
	{text = "Butterfly", data = "butterfly"},
	{text = "Charcoal", data = "charcoal"},
	{text = "Chester Eyebone", data = "chester_eyebone"},
	{text = "Compass", data = "compass"},-- I
	{text = "Crow Feather", data = "feather_crow"},
	{text = "Cut Grass", data = "cutgrass"},
	{text = "Cut Reeds", data = "cutreeds"},
	{text = "Deerclops Eye", data = "deerclops_eyeball"},
	{text = "Divining Rod", data = "diviningrod"},
	{text = "Dug Berrybush", data = "dug_berrybush"},
	{text = "Dug Berrybush 2", data = "dug_berrybush2"},
	{text = "Dug Grass", data = "dug_grass"},
	{text = "Dug Sapling", data = "dug_sapling"},
	{text = "Fireflies", data = "fireflies"},
	{text = "Flint", data = "flint"},
	{text = "Gears", data = "gears"},
	{text = "Gold Nugget", data = "goldnugget"},
	{text = "Guano, Bat", data = "guano"}, -- I
	{text = "Honeycomb", data = "honeycomb"},
	{text = "Hounds Tooth", data = "houndstooth"},
	{text = "Krampus Sack", data = "krampus_sack"},
	{text = "Lantern", data = "lantern"},-- I
	{text = "Lightbulb", data = "lightbulb"}, -- I
	{text = "Lighter", data = "lighter"},-- I
	{text = "Living Log", data = "livinglog"},
	{text = "Log", data = "log"},
	{text = "Lureplantbulb", data = "lureplantbulb"},-- I
	{text = "Lucy", data = "lucy"},-- I
	{text = "Marble", data = "marble"},
	{text = "Manure", data = "poop"},
	{text = "Nightmare Fuel", data = "nightmarefuel"},
	{text = "Nitre", data = "nitre"},
	{text = "Pig Skin", data = "pigskin"},
	{text = "Pinecone", data = "pinecone"},
	{text = "Red Gem", data = "redgem"},
	{text = "Robin Feather", data = "feather_robin"},
	{text = "Rocks", data = "rocks"},
	{text = "Silk ", data = "silk"},
	{text = "Slurtle Hat", data = "slurtlehat"}, -- I
	{text = "Snurtle Shell", data = "armorsnurtleshell"}, -- I
	{text = "SlurtleSlime", data = "slurtleslime"}, -- I
	{text = "Spider Eggs", data = "spidereggsack"},
	{text = "Spider Gland", data = "spidergland"},
	{text = "Spiderhat", data = "spiderhat"},
	{text = "Stinger", data = "stinger"},
	{text = "Summer K. Trunk", data = "trunk_summer"},
	{text = "Tam o'Shanter", data = "walrushat"},
	{text = "Tent", data = "tent"}, 
	{text = "Tentacle Spike", data = "tentaclespike"},
	{text = "Tentacle Spots", data = "tentaclespots"},
	{text = "Turf Forest", data = "turf_forest"},
	{text = "Turf Grass", data = "turf_grass"},
	{text = "Turf Marsh", data = "turf_marsh"},
	{text = "Turf Rocky", data = "turf_rocky"},
	{text = "Turf Savanna", data = "turf_savanna"},
	{text = "Twigs", data = "twigs"},
	{text = "Walrus Tusk", data = "walrus_tusk"},
	{text = "W. K. Trunk", data = "trunk_winter"},
	{text = "W. Robin Feather", data = "feather_robin_winter"},
}

local foodItemOptions = {
	--{text = "abigail_flower", data = "abigail_flower"},
	{text = "Bacon & Eggs", data = "baconeggs"},
	{text = "Banana", data = "cave_banana"},-- T
	{text = "Banana Cooked", data = "cave_banana_cooked"},-- T
	{text = "Berries", data = "berries"},
	{text = "Blue Cap", data = "blue_cap"},
	{text = "Braised Eggplant", data = "eggplant_cooked"},
	{text = "Buttefly Muffin", data = "butterflymuffin"},
	{text = "Buttefly Wings", data = "butterflywings"},
	{text = "Butter", data = "butter"},
	{text = "Carrot", data = "carrot"},
	{text = "Cooked Dragon Fruit", data = "dragonfruit_cooked"},
	{text = "Cooked Durian", data = "durian_cooked"},
	{text = "Cooked Fish", data = "fish_cooked"},
	{text = "Cooked Froglegs", data = "froglegs_cooked"},
	{text = "Cooked M. Meat", data = "cookedmonstermeat"},
	{text = "Cooked Mandrake", data = "cookedmandrake"},
	{text = "Cooked Meat", data = "cookedmeat"},
	{text = "Cooked Morsel", data = "cookedsmallmeat"},
	{text = "Corn", data = "corn"},
	{text = "Dark Petals", data = "petals_evil"},
	{text = "Deadly Feast", data = "deadlyfeast"},
	{text = "Dragonfruit", data = "dragonfruit"},
	{text = "Dragonpie", data = "dragonpie"},
	{text = "Drumstick", data = "drumstick"},
	{text = "Durian", data = "durian"},
	{text = "Eggplant", data = "eggplant"},
	{text = "Fish", data = "fish"},
	{text = "Fish Sticks", data = "fishsticks"},
	{text = "Fish Tacos", data = "fishtacos"},
	{text = "Fried Drumstick", data = "drumstick_cooked"},
	{text = "Fried T. Egg", data = "tallbirdegg_cooked"},
	{text = "Frog Legs", data = "froglegs"},
	{text = "Froggle Bunwich", data = "frogglebunwich"},
	{text = "Fruit Medley", data = "fruitmedley"},
	{text = "Green Cap", data = "green_cap"},
	{text = "Honey", data = "honey"},
	{text = "Honey Ham", data = "honeyham"},
	{text = "Honey Nuggets", data = "honeynuggets"},
	{text = "Jam", data = "jammypreserves"},
	{text = "K. Trunk Steak", data = "trunk_cooked"},
	{text = "Kabobs", data = "kabobs"},
	{text = "Mandrake", data = "mandrake"},
	{text = "Mandrake Soup", data = "mandrakesoup"},
	{text = "Meat", data = "meat"},
	{text = "Meatballs", data = "meatballs"},
	{text = "Meaty Stew", data = "bonestew"},
	{text = "Monster Lasagna", data = "monsterlasagna"},
	{text = "Monster Meat", data = "monstermeat"},
	{text = "Morsel", data = "smallmeat"},
	{text = "Nightmare Lock", data = "maxwelllock"},
	{text = "Petals", data = "petals"},
	{text = "Pierogi", data = "perogies"},
	{text = "Pomegranate", data = "pomegranate"},
	{text = "Popcorn", data = "corn_cooked"},
	{text = "PowCake", data = "powcake"}, -- T
	{text = "Pumpkin", data = "pumpkin"},
	{text = "Pumpkin Cookie", data = "pumpkincookie"},
	{text = "Ratatouille", data = "ratatouille"},
	{text = "Red Cap", data = "red_cap"},
	{text = "Roasted Berries", data = "berries_cooked"},
	{text = "Roasted Carrot", data = "carrot_cooked"},
	{text = "Rot", data = "spoiled_food"},
	{text = "Rotten Egg", data = "rottenegg"},
	{text = "Seeds", data = "seeds"},
	{text = "Shadow Key", data = "maxwellkey"},
	{text = "Sliced Pomegranate", data = "pomegranate_cooked"},
	{text = "Stuffed Eggplant", data = "stuffedeggplant"},
	{text = "Taffy", data = "taffy"},
	{text = "Tallbird Egg", data = "tallbirdegg"},
	{text = "Toasted Seeds", data = "seeds_cooked"},
	{text = "Turkey Dinner", data = "turkeydinner"},
	{text = "Waffles", data = "waffles"},
	{text = "Wet Goop", data = "wetgoop"},
	{text = "carrot_seeds", data = "carrot_seeds"},
	{text = "durian_seeds", data = "durian_seeds"},
	{text = "eggplant_seeds", data = "eggplant_seeds"},
	{text = "pomegranate_seeds", data = "pomegranate_seeds"},
	{text = "pumpkin_seeds", data = "pumpkin_seeds"},
}

local objectOptions = {
	{text = "Balloon", data = "balloon"},-- O
	{text = "Banana Tree", data = "cave_banana_tree"},-- O
	{text = "Basalt Pillar", data = "basalt_pillar"},
	{text = "Basalt Rock", data = "basalt"},
	{text = "Beehive", data = "beehive"},
	{text = "Beemine", data = "beemine"},
	{text = "Berry Bush", data = "berrybush"},
	{text = "Berry Bush 2", data = "berrybush2"},
	{text = "Bird Trap", data = "birdtrap"},
	{text = "Bones", data = "houndbone"},
	{text = "Bonfire", data = "bonfire"},
	{text = "Boulder 1", data = "rock1"},
	{text = "Boulder 2", data = "rock2"},
	{text = "Boulder 3", data = "rock_flintless"}, 
	{text = "Bunny, Cave", data = "bunnyman"}, -- O
	{text = "Bunny House", data = "rabbithouse"}, -- O
	{text = "Cave Entrance", data = "cave_entrance"}, -- O
	{text = "Cave Flower", data = "flower_cave"}, -- O
	{text = "Divining Rod Base", data = "diviningrodbase"},
	{text = "Divining Rod Holder", data = "diviningrodstart"},
	{text = "Evergreen Burnt", data = "evergreen_burnt"},
	{text = "Evergree Normal", data = "evergreen_normal"},
	{text = "Evergreen Short", data = "evergreen_short"},
	{text = "Evergreen Stump", data = "evergreen_stump"},
	{text = "Evergreen Tall", data = "evergreen_tall"},
	{text = "Evil Flower", data = "flower_evil"},
	{text = "Fern, cave", data = "cave_fern"},-- O
	{text = "Fireflies", data = "fireflies"},
	{text = "Flower", data = "flower"},
	{text = "Grass", data = "grass"},
	{text = "Gravestone", data = "gravestone"},
	{text = "Harp Statue", data = "statueharp"},
	{text = "Hound Mound", data = "houndmound"},
	{text = "Killer Hive", data = "wasphive"},
	{text = "Lumpy E. Normal", data = "evergreen_sparse_normal"},
	{text = "Lumpy E. Short", data = "evergreen_sparse_short"},
	{text = "Lumpy E. Tall", data = "evergreen_sparse_tall"},
	{text = "Locked Wes", data = "lockedwes"},
	{text = "Lightningrod", data = "lightning_rod"}, 
	{text = "Marble Pillar", data = "marblepillar"},
	{text = "Marble Tree", data = "marbletree"},
	{text = "Marsh Bush", data = "marsh_bush"},
	{text = "Marsh Plant", data = "marsh_plant"},
	{text = "Marsh Tree", data = "marsh_tree"},
	{text = "Maxwell End", data = "maxwellendgame"},
	{text = "Maxwell Statue", data = "statuemaxwell"},
	{text = "Maxwell Throne", data = "maxwellthrone"},
	{text = "Maxwell Tooth Trap", data = "trap_teeth_maxwell"},
	{text = "Maxwell's Door", data = "adventure_portal"},
	{text = "Maxwell Head", data = "maxwellhead"},
	{text = "Maxwell's Light", data = "maxwelllight"},
	{text = "Maxwell's Phonograph", data = "maxwellphonograph"},
	{text = "Meat Effigy", data = "resurrectionstatue"},
	{text = "Merm Head", data = "mermhead"},
	{text = "Merm House", data = "mermhouse"},
	{text = "Mound", data = "mound"},
	{text = "MushTree Tall", data = "mushtree_tall"}, -- O
	{text = "MushTree Med", data = "mushtree_medium"}, -- O
	{text = "MushTree SM", data = "mushtree_small"}, -- O
	{text = "Mushroom Blue", data = "blue_mushroom"},
	{text = "Mushroom Green", data = "green_mushroom"},
	{text = "Mushroom Red", data = "red_mushroom"},
	{text = "Obelisk Insanity", data = "sanityrock"},
	{text = "Obelisk Sanity", data = "insanityrock"},
	{text = "Pig Head", data = "pighead"},
	{text = "Pig House", data = "pighouse"},
	{text = "Pig Torch", data = "pigtorch"},
	{text = "Planted Carrot", data = "carrot_planted"},
	{text = "Pond Frog", data = "pond"},
	{text = "Pond Mosquito", data = "pond_mos"},
	{text = "Rabbit Hole", data = "rabbithole"},
	{text = "Rainometer", data = "rainometer"}, 
	{text = "Reeds", data = "reeds"},
	{text = "Res Stone", data = "resurrectionstone"}, 
	{text = "Sapling", data = "sapling"},
	{text = "Sick Worm Hole", data = "wormhole_limited_1"},
	{text = "Skeleton", data = "skeleton"},
	{text = "Spiderden", data = "spiderden"},
	{text = "Stalagmite small", data = "stalagmite"}, -- O
	{text = "Stalagmite tall", data = "stalagmite_tall"},-- O
	{text = "Tallbird Nest", data = "tallbirdnest"},
	{text = "Teleport Base", data = "teleportato_base"},
	{text = "Telebase", data = "telebase"},-- O
	{text = "Teleport Box", data = "teleportato_box"},
	{text = "Teleport Crank", data = "teleportato_crank"},
	--{text = "Teleportato End", data = "teleportato_checkmate"}, --no longer works
	{text = "Teleport Potato", data = "teleportato_potato"},
	{text = "Teleport Ring", data = "teleportato_ring"},
	{text = "Tentacle_garden", data = "tentacle_garden"},-- O
	{text = "Tooth Trap", data = "trap_teeth"},
	{text = "Touch Stone", data = "resurrectionstone"},
	{text = "Wall Grass", data = "wall_hay"},
	{text = "Wall Stone", data = "wall_stone"},
	{text = "Wall Wood", data = "wall_wood"},
	{text = "Walrus Camp", data = "walrus_camp"},
	{text = "Winterometer", data = "winterometer"}, 
	{text = "Worm Hole", data = "wormhole"},
}
local index_2_Options = {
	{text = "Book, sleep", data = "book_sleep"},-- M
	{text = "Book, gardening", data = "book_gardening"},-- M
	{text = "Book, brimstone", data = "book_brimstone"},-- M
	{text = "Book, birds", data = "book_birds"},-- M
	{text = "Book, tentacles", data = "book_tentacles"},-- M
	{text = "Gem, Purple", data = "purplegem"},-- M
	{text = "Gem, Blue", data = "bluegem"},-- M
	{text = "Gem, Red", data = "redgem"},-- M
	{text = "Gem, Orange", data = "orangegem"},--- M
	{text = "Gem, Yellow", data = "yellowgem"},-- M
	{text = "Gem, Green", data = "greengem"},-- M
	{text = "Staff, Ice", data = "icestaff"},-- M
	{text = "Staff, Fire", data = "firestaff"},-- M
	{text = "Staff, Tele", data = "telestaff"},-- M
	{text = "Staff, Orange", data = "orangestaff"},-- M
	{text = "Staff, Green", data = "greenstaff"},-- M
	{text = "Staff, Yellow", data = "yellowstaff"},-- M
}
-- Updates --
local spinnerFont = {font = text_font, size = 24} --30
local spinnerHeight = 48 --64

TestScreen = Class(Screen, function(self, displayed)
	Screen._ctor(self, "TestScreen")

	local graphicsOptions = TheFrontEnd:GetGraphicsOptions()

	self.options = {
		entityPrefab = nil,
		itemPrefab = nil,
		foodPrefab = nil,
		objectPrefab = nil,
		item_2_Prefab = nil,
	}

	local indexTable = {}

	indexTable = self:RetrieveIndices()

	self.entityIndex = indexTable[1] or 1
	self.itemIndex = indexTable[2] or 1
	self.foodIndex = indexTable[3] or 1
	self.speedIndex = indexTable[4] or 1
	self.objectIndex = indexTable[5] or 1
	self.item_2_Index = indexTable[6] or 1 -- magic --
	self.displayed = displayed
	self.working = deepcopy(self.options)

	self:DoInit()
	self:InitializeSpinners()
end)

function string.starts(String,Start)
	Start = string.upper(Start)
	return string.sub(String,1,string.len(Start)) == Start
end

function TestScreen:OnTextInput(text)
	local spinner = self:GetActiveFocusWidget()
	
	local index = 1

	for k,v in pairs(spinner.options) do
		if string.starts(v.text, text) then
			spinner:SetSelectedIndex(index)
			break
		end	
		
		index = index + 1
	end
end

function TestScreen:OnKeyUp(key)
	if key == KEY_ESCAPE then
		self:Close()
	end
end

function TestScreen:OnKeyDown(key)
	if (key == KEY_TAB) and not TheInput:IsKeyDown(KEY_ALT) then
		self:AdvanceFocus( not TheInput:IsKeyDown(KEY_SHIFT) )
	end
end

function TestScreen:Accept()
	self:Save(function()
	self:Close()
	end)
end

function TestScreen:Save(cb)
	self.options = deepcopy(self.working)
	Profile:Save(function()
	if cb then
	  cb()
	end
	end)
end

function TestScreen:Close()
	TheSim:SetSetting("TEST_TOOLS", "entityIndex", self.entitySpinner:GetSelectedIndex())
	TheSim:SetSetting("TEST_TOOLS", "itemIndex", self.itemSpinner:GetSelectedIndex())
	TheSim:SetSetting("TEST_TOOLS", "foodIndex", self.foodSpinner:GetSelectedIndex())
	TheSim:SetSetting("TEST_TOOLS", "speedIndex", self.speedSpinner:GetSelectedIndex())
	TheSim:SetSetting("TEST_TOOLS", "objectIndex", self.objectSpinner:GetSelectedIndex())
	TheSim:SetSetting("TEST_TOOLS", "item_2_Index", self.item_2_Spinner:GetSelectedIndex()) -- magic --

	TheFrontEnd:PopScreen(self)
	self.displayed = false
	SetHUDPause(false)
end

function TestScreen:RetrieveIndices()
	local values = {}

	table.insert(values, TheSim:GetSetting("TEST_TOOLS", "entityIndex") or 1)
	table.insert(values, TheSim:GetSetting("TEST_TOOLS", "itemIndex") or 1)
	table.insert(values, TheSim:GetSetting("TEST_TOOLS", "foodIndex") or 1)
	table.insert(values, TheSim:GetSetting("TEST_TOOLS", "speedIndex") or 1)
	table.insert(values, TheSim:GetSetting("TEST_TOOLS", "objectIndex") or 1)
	table.insert(values, TheSim:GetSetting("TEST_TOOLS", "item_2_Index") or 1) -- magic --

	return values
end

local MakeMenu = function(offset, menuitems)
	local menu = Widget("OptionsMenu")
	local pos = Vector3(0, 0, 0)
	
	for k, v in ipairs(menuitems) do
		local button = menu:AddChild(AnimButton("button"))
		button:SetPosition(pos)
		button:SetText(v.text)
		button.text:SetColour(0, 0, 0, 1)
		button:SetOnClick(v.cb)
		button:SetFont(BUTTONFONT)
		button:SetTextSize(40)
		pos = pos + offset
	end
	
	return menu
end

function TestScreen:AddSpinners(data, user_offset, bg_size)
	local master_group = self:AddChild(Widget("SpinnerGroup"))
	master_group:SetVAnchor(ANCHOR_TOP)
	master_group:SetHAnchor(ANCHOR_MIDDLE)
	
	local offset = {0, 0, 0}
	if user_offset then
		offset[1] = offset[1] + user_offset[1]
		offset[2] = offset[2] + user_offset[2]
		offset[3] = offset[3] + user_offset[3]
	end
	local centerV = -RESOLUTION_Y/4
	master_group:SetPosition(offset[1], offset[2] + centerV, offset[2]) --first offset = horizontal.  second offset is vertical
	
	local label_width = 200
	
	for idx, entry in ipairs(data) do
		local text = entry[1]
		local spinner = entry[2]
		local group = master_group:AddChild(Widget("SpinnerGroup"))
		group:SetPosition(0, (idx - 1) * -75 + 25, 0)
		local label = group:AddChild(Text(DEFAULTFONT, 30, text))
		label:SetPosition(0.5 * label_width, 0, 0)
		label:SetRegionSize(label_width, 50)
		label:SetHAlign(ANCHOR_RIGHT)
		group:AddChild(spinner)
		spinner:SetPosition(label_width + 32, 0, 0)
		spinner:SetWrapEnabled(true)
		spinner:SetLeftMouseDown(function() self:SetFocus(spinner) end)
	end
	
	return master_group
end

function TestScreen:DoInit()
	--below uses Klei's gray background with tint:
    self.bg = self:AddChild(Image("images/ui.xml", "bg_plain.tex"))
	self.bg:SetTint(BGCOLOURS.RED[1],BGCOLOURS.RED[2],BGCOLOURS.RED[3], 1)
    --self.bg = self:AddChild(Image("mods/Test Tools/scripts/images/bg_red.xml", "bg_red.tex"))
    self.bg:SetVRegPoint(ANCHOR_MIDDLE)
    self.bg:SetHRegPoint(ANCHOR_MIDDLE)
    self.bg:SetVAnchor(ANCHOR_MIDDLE)
    self.bg:SetHAnchor(ANCHOR_MIDDLE)
    self.bg:SetScaleMode(SCALEMODE_FILLSCREEN)
    
	self.root = self:AddChild(Widget("ROOT"))
    self.root:SetVAnchor(ANCHOR_MIDDLE)
    self.root:SetHAnchor(ANCHOR_MIDDLE)
    self.root:SetPosition(0,0,0)
    self.root:SetScaleMode(SCALEMODE_PROPORTIONAL)

	
	local menu_items = {
		{ text = "Keys", cb = function() TheFrontEnd:PushScreen(KeyScreen({ {text="Back", cb = function() end}})) end },	
		{ text = "Close", cb = function() self:Accept() end }
	}
----- Menu buttons
	if self.menu then
		self.menu:Kill()
	end
	
	local menu_spacing = 60
	local bottom_offset = 70
	local this = self
----- Menu buttons
	self.itemSpinner = Spinner(uncraftableItemOptions, 180, spinnerHeight, spinnerFont, spinner_atlas, spinner_images)
	  function self.itemSpinner:OnChanged(data)
			this.working.itemPrefab = data
			this:UpdateSelectedItem()
			self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex"))
			self.image:SetScale(0.8,0.8,0.8)
			self.image:SetPosition(115,-75,0)
			self.image = self:AddChild(Image("images/inventoryimages.xml", data.. ".tex"))
			
			self.image:SetPosition(115,-75,0)
	  end

	self.foodSpinner = Spinner(foodItemOptions, 180, spinnerHeight, spinnerFont, spinner_atlas, spinner_images)
		function self.foodSpinner:OnChanged(data)
			this.working.foodPrefab = data
			this:UpdateSelectedFood()
			self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex"))
			self.image:SetScale(0.8,0.8,0.8)
			self.image:SetPosition(115,-75,0)
			self.image = self:AddChild(Image("images/inventoryimages.xml", data.. ".tex"))
			self.image:SetPosition(115,-75,0)
		end

-------- OBJECTS ------
	self.objectSpinner = Spinner(objectOptions, 180, spinnerHeight, spinnerFont, spinner_atlas, spinner_images)
		function self.objectSpinner:OnChanged(data)
			this.working.objectPrefab = data
			this:UpdateSelectedObject()
----------
self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex"))
self.image:SetScale(2,2,2) -- large portrait box
self.image:SetPosition(500,0,0)

local my_anim = self:AddChild(UIAnim(data))
my_anim:GetAnimState():SetBank(data)
my_anim:GetAnimState():SetBuild(data)
my_anim:GetAnimState():PlayAnimation("idle")
--if my_anim:GetAnimState():SetBank(data) then
my_anim:SetScale(0.25,0.25,0.25)
my_anim:SetPosition(500,-50,0)
--else
--self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex")) -- this can be customized to say "Image Not Available"
--end

end


---------- ENTITYS -------
		self.entitySpinner = Spinner(entityOptions, 180, spinnerHeight, spinnerFont, spinner_atlas, spinner_images)
	  function self.entitySpinner:OnChanged(data)
			this.working.entityPrefab = data
			this:UpdateSelectedEntity()
self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex"))
self.image:SetScale(2,2,2) -- large portrait box
self.image:SetPosition(500,75,0)

local my_anim = self:AddChild(UIAnim(data))
my_anim:GetAnimState():SetBank(data)
my_anim:GetAnimState():SetBuild(data)
my_anim:GetAnimState():PlayAnimation("idle")
--if my_anim:GetAnimState():SetBank(data) then
my_anim:SetScale(0.5,0.5,0.5)
my_anim:SetPosition(500,0,0)
--else
--self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex")) -- this can be customized to say "Image Not Available"
--end
	  end
-- magic --
		self.item_2_Spinner = Spinner(index_2_Options, 180, spinnerHeight, spinnerFont, spinner_atlas, spinner_images)
		function self.item_2_Spinner:OnChanged(data)
			this.working.item_2_Prefab = data
			this:UpdateSelected_2_Index()
			self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex"))
			self.image:SetScale(0.8,0.8,0.8)
			self.image:SetPosition(115,-75,0)
			self.image = self:AddChild(Image("images/inventoryimages.xml", data.. ".tex"))
			self.image:SetPosition(115,-75,0)
		end
-- magic --
	self.speedSpinner = NumericSpinner( 2, 10, 50, spinnerHeight, spinnerFont, spinner_atlas, spinner_images )
	self.speedSpinner.OnChanged =
		function( self, data )
			this:UpdateSpeedMultiplier()
		end 
		
	self.godmodeSpinner = Spinner(enableDisableOptions, 50, spinnerHeight, spinnerFont, spinner_atlas, spinner_images)
		function self.godmodeSpinner:OnChanged(data)
			this:UpdateGodMode()
		end

	local spawning_spinners = {}
	local option_spinners = {}
	local toggle_spinners = {}

	local spawn_pos, option_pos, toggle_pos, bg_pos, bg_size

	table.insert(spawning_spinners, { "Item: (Ctrl-X)", self.itemSpinner })
	table.insert(spawning_spinners, { "", self.godmodeSpinner }) --makes a blank line
	table.insert(spawning_spinners, { "Food: (Ctrl-T)", self.foodSpinner })
	table.insert(spawning_spinners, { "", self.godmodeSpinner }) --makes a blank line
	table.insert(spawning_spinners, { "Object: (Shift-O)", self.objectSpinner })
	table.insert(spawning_spinners, { "Entity: (Shift-Z)", self.entitySpinner })
	
	table.insert(spawning_spinners, { "God Mode:", self.godmodeSpinner })
	table.insert(spawning_spinners, { "Speed Multiplier:", self.speedSpinner })
	table.insert(toggle_spinners, { "Magic: (Alt-L)", self.item_2_Spinner }) -- magic --
	
	local centerH = -RESOLUTION_X/2.5 -- Horizontal position of 'prefab' column
	local centerO = RESOLUTION_X/15 -- Horizontal position of 'toggle' column
	print (centerH)
	print (centerO)
	spawn_pos = {centerH, 75, 0} --Vertical position of all prefab items table
	toggle_pos = {centerO,75,0} --Vertical postion of all 'toggle' items (right side)
	bg_pos = {640, 360,0}
	bg_size = {1000, 700}


	local spawn_group = self:AddSpinners(spawning_spinners, spawn_pos)
	local option_group = self:AddSpinners(option_spinners, option_pos)
	local toggle_group = self:AddSpinners(toggle_spinners, toggle_pos)
	
	self:PushFocusWidget(self.entitySpinner)
	self:PushFocusWidget(self.itemSpinner)
	self:PushFocusWidget(self.foodSpinner)
	self:PushFocusWidget(self.objectSpinner)
	self:PushFocusWidget(self.item_2_Spinner)-- magic --

	self.soundmenu = self:AddChild(MakeMenu(Vector3(0, -menu_spacing, 0), menu_items))
--Keys and Close button placement:
	self.soundmenu:SetHAnchor(ANCHOR_RIGHT)
	self.soundmenu:SetPosition(-120, bottom_offset + menu_spacing * (#menu_items - 1), 0)
end

local EnabledOptionsIndex = function(enabled)
	if enabled then
		return 2
	else
		return 1
	end
end

local function GodModeIndex()
	if GetPlayer().components.health:IsInvincible() then
		return 2
	else
		return 1
	end
end

function TestScreen:UpdateSelectedEntity()
	if self.entitySpinner:GetSelected().data then
		GetPlayer().components.testtoolcontroller.entityPrefab = self.entitySpinner:GetSelectedData()
	end
end

function TestScreen:UpdateSelectedItem()
	if self.itemSpinner:GetSelected().data then
		GetPlayer().components.testtoolcontroller.itemPrefab = self.itemSpinner:GetSelectedData()
	end
end

function TestScreen:UpdateSelectedFood()
	if self.foodSpinner:GetSelected().data then
		GetPlayer().components.testtoolcontroller.foodPrefab = self.foodSpinner:GetSelectedData()
	end
end

function TestScreen:UpdateSelectedObject()
	if self.objectSpinner:GetSelected().data then
		GetPlayer().components.testtoolcontroller.objectPrefab = self.objectSpinner:GetSelectedData()
	end
end
-- magic --
function TestScreen:UpdateSelected_2_Index()
	if self.item_2_Spinner:GetSelected().data then
		GetPlayer().components.testtoolcontroller.item_2_Prefab = self.item_2_Spinner:GetSelectedData()
		end
end
-- magic --
function TestScreen:UpdateSpeedMultiplier()
	if self.speedSpinner:GetSelected() then
		GetPlayer().components.testtoolcontroller.speed_multiplier = self.speedSpinner:GetSelectedData()
	end
end

function TestScreen:UpdateGodMode()
	if self.godmodeSpinner:GetSelected() then
		local value = self.godmodeSpinner:GetSelectedData()
		GetPlayer().components.health:SetInvincible(value)
	end
end

----------------------------------------------------------------------
function TestScreen:InitializeSpinners()
	self.entitySpinner:SetSelectedIndex(self.entityIndex)
	self:UpdateSelectedEntity()

	self.itemSpinner:SetSelectedIndex(self.itemIndex)
	self:UpdateSelectedItem()

	self.foodSpinner:SetSelectedIndex(self.foodIndex)
	self:UpdateSelectedFood()

	self.objectSpinner:SetSelectedIndex(self.objectIndex)
	self:UpdateSelectedObject()
-- magic --
	self.item_2_Spinner:SetSelectedIndex(self.item_2_Index)
	self:UpdateSelected_2_Index()
-- magic --	
	self.speedSpinner:SetSelectedIndex(self.speedIndex)
	self:UpdateSpeedMultiplier()

	self.godmodeSpinner:SetSelectedIndex(GodModeIndex())
	self:UpdateGodMode()
end
