require("util")
require("screen")
require("button")
require("animbutton")
require("image")
require("uianim")
require("spinner")
require("numericspinner")
require("screens/popupdialog")
require "textbutton"
require "widgets/toggle"
require("screens/keyscreen")

local spinner_atlas = "images/ui.xml"

local spinner_images = {
	arrow_normal = "spin_arrow.tex",
	arrow_over = "spin_arrow_over.tex",
	arrow_disabled = "spin_arrow_disabled.tex",
	bgtexture = "spinner.tex"
}

local text_font = DEFAULTFONT

local enableDisableOptions = { { text = "NO", data = false }, { text = "YES", data = true } }

local entityOptions = {
	{text = "ȸǶ", data = "abigail"},
	{text = "Сţ", data = "babybeefalo"},
	{text = "", data = "bat"}, -- E
	{text = "۷", data = "bee"},
	{text = "ţ", data = "beefalo"},
	{text = "ɫȮ", data = "icehound"},
	{text = "", data = "butterfly"},
	{text = "˹", data = "chester"},
	{text = "", data = "bishop"},
	{text = "ʿ", data = "knight"},
	{text = "Crawling Horror", data = "crawlinghorror"},
	{text = "ѻ", data = "crow"},
	{text = "¹", data = "deerclops"},
	{text = "֮", data = "eyeplant"},-- E
	{text = "ɫȮ", data = "firehound"},
	{text = "", data = "frog"},
	{text = "", data = "ghost"},
	{text = "", data = "perd"},
	{text = "Ȯ", data = "hound"},
	{text = "ɱ˷", data = "killerbee"},
	{text = "˹", data = "krampus"},
	{text = "", data = "walrus"},
	{text = "", data = "mandrake"},
	{text = "", data = "merm"},
	{text = "Ѩ̽", data = "monkey"},-- E
	{text = "", data = "monkeybarrel"},-- E
	{text = "", data = "mosquito"},
	{text = "", data = "penguin"},-- E
	{text = "", data = "pigguard"},
	{text = "", data = "pigking"},
	{text = "", data = "pigman"},
	{text = "", data = "rabbit"},
	{text = "ȸ", data = "robin"},
	{text = "ʯϺ", data = "rocky"},-- E
	{text = "Ӱ", data = "shadowskittish"},
	{text = "", data = "slurtle"}, -- E
	{text = "С", data = "smallbird"},
	{text = "֩ ", data = "spider"},
	{text = "֩Ů", data = "spiderqueen"},
	{text = "֩սʿ ", data = "spider_warrior"},
	{text = "Ѩ֩", data = "spider_hider"}, -- E
	{text = "", data = "spider_spitter"}, -- E
	{text = "ļ", data = "koalefant_summer"},
	{text = "", data = "tallbird"},
	{text = "С", data = "teenbird"},
	{text = "Tentacle", data = "tentacle"},
	{text = "", data = "terrorbeak"},
	{text = "С", data = "tentacle_pillar_arm"},-- E
	{text = "", data = "leif"},
	{text = "Waxwell()", data = "waxwell"},
	{text = "С", data = "little_walrus"},
	{text = "ɫ", data = "koalefant_winter"},
	{text = "ȸ", data = "robin_winter"},
}

local uncraftableItemOptions = { 
	{text = "ҽ", data = "ash"},
	{text = "", data = "batbat"}, -- I
	{text = "", data = "beardhair"},
	{text = "۷", data = "bee"},
	{text = "ţ", data = "horn"},
	{text = "ţë", data = "beefalowool"},
	{text = "ʯ", data = "bluegem"},
	{text = "ë", data = "manrabbit_tail"}, -- I
	{text = "", data = "butterfly"},
	{text = "ľ̿", data = "charcoal"},
	{text = "˹۹", data = "chester_eyebone"},
	{text = "ָ", data = "compass"},-- I
	{text = "ɫë", data = "feather_crow"},
	{text = "", data = "cutgrass"},
	{text = "õ«έ", data = "cutreeds"},
	{text = "¹۾", data = "deerclops_eyeball"},
	{text = "ħ", data = "diviningrod"},
	{text = "ľ", data = "dug_berrybush"},
	{text = "ľ 2", data = "dug_berrybush2"},
	{text = "", data = "dug_grass"},
	{text = "", data = "dug_sapling"},
	{text = "ө", data = "fireflies"},
	{text = "ʯ", data = "flint"},
	{text = "", data = "gears"},
	{text = "", data = "goldnugget"},
	{text = "", data = "guano"}, -- I
	{text = "䳲", data = "honeycomb"},
	{text = "", data = "houndstooth"},
	{text = "˹", data = "krampus_sack"},
	{text = "", data = "lantern"},-- I
	{text = "ӫ", data = "lightbulb"}, -- I
	{text = "", data = "lighter"},-- I
	{text = "֮ľ", data = "livinglog"},
	{text = "ľ", data = "log"},
	{text = "ʳ˻֮", data = "lureplantbulb"},-- I
	{text = "Lucy", data = "lucy"},-- I
	{text = "ʯ", data = "marble"},
	{text = "", data = "poop"},
	{text = "جξ", data = "nightmarefuel"},
	{text = "ʯ", data = "nitre"},
	{text = "Ƥ", data = "pigskin"},
	{text = "ɹ", data = "pinecone"},
	{text = "챦ʯ", data = "redgem"},
	{text = "ɫë", data = "feather_robin"},
	{text = "ʯ", data = "rocks"},
	{text = "˿ ", data = "silk"},
	{text = "ͷ", data = "slurtlehat"}, -- I
	{text = "Ǽ", data = "armorsnurtleshell"}, -- I
	{text = "ճҺ", data = "slurtleslime"}, -- I
	{text = "֩", data = "spidereggsack"},
	{text = "֩", data = "spidergland"},
	{text = "֩ñ", data = "spiderhat"},
	{text = "", data = "stinger"},
	{text = "ɫ", data = "trunk_summer"},
	{text = "ñ", data = "walrushat"},
	{text = "", data = "tent"}, 
	{text = "", data = "tentaclespike"},
	{text = "ߵ㴥Ƥ", data = "tentaclespots"},
	{text = "ɭֲƤ", data = "turf_forest"},
	{text = "ݲƤ", data = "turf_grass"},
	{text = "Ƥ", data = "turf_marsh"},
	{text = "ʯƤ", data = "turf_rocky"},
	{text = "ȴԭƤ", data = "turf_savanna"},
	{text = "֦", data = "twigs"},
	{text = "", data = "walrus_tusk"},
	{text = "ɫ", data = "trunk_winter"},
	{text = "ɫë", data = "feather_robin_winter"},
}

local foodItemOptions = {
	--{text = "abigail_flower", data = "abigail_flower"},
	{text = "", data = "baconeggs"},
	{text = "㽶", data = "cave_banana"},-- T
	{text = "㽶", data = "cave_banana_cooked"},-- T
	{text = "", data = "berries"},
	{text = "ͷ", data = "blue_cap"},
	{text = "", data = "eggplant_cooked"},
	{text = "ɱ", data = "butterflymuffin"},
	{text = "", data = "butterflywings"},
	{text = "", data = "butter"},
	{text = "ܲ", data = "carrot"},
	{text = "ƻ", data = "dragonfruit_cooked"},
	{text = "", data = "durian_cooked"},
	{text = "", data = "fish_cooked"},
	{text = "", data = "froglegs_cooked"},
	{text = "", data = "cookedmonstermeat"},
	{text = "", data = "cookedmandrake"},
	{text = "", data = "cookedmeat"},
	{text = "С", data = "cookedsmallmeat"},
	{text = "", data = "corn"},
	{text = "ħ", data = "petals_evil"},
	{text = "", data = "deadlyfeast"},
	{text = "", data = "dragonfruit"},
	{text = "ڱ", data = "dragonpie"},
	{text = "", data = "drumstick"},
	{text = "", data = "durian"},
	{text = "", data = "eggplant"},
	{text = "", data = "fish"},
	{text = "", data = "fishsticks"},
	{text = "ըױ", data = "fishtacos"},
	{text = "ը", data = "drumstick_cooked"},
	{text = "", data = "tallbirdegg_cooked"},
	{text = "", data = "froglegs"},
	{text = "", data = "frogglebunwich"},
	{text = "ˮƴ", data = "fruitmedley"},
	{text = "̹ͷ", data = "green_cap"},
	{text = "", data = "honey"},
	{text = "֭", data = "honeyham"},
	{text = "֭±", data = "honeynuggets"},
	{text = "", data = "jammypreserves"},
	{text = "", data = "trunk_cooked"},
	{text = "⴮", data = "kabobs"},
	{text = "", data = "mandrake"},
	{text = "", data = "mandrakesoup"},
	{text = "", data = "meat"},
	{text = "", data = "meatballs"},
	{text = "", data = "bonestew"},
	{text = "", data = "monsterlasagna"},
	{text = "", data = "monstermeat"},
	{text = "С", data = "smallmeat"},
	{text = "ج", data = "maxwelllock"},
	{text = "", data = "petals"},
	{text = "ԲСֱ", data = "perogies"},
	{text = "ʯ", data = "pomegranate"},
	{text = "׻", data = "corn_cooked"},
	{text = "ҩ", data = "powcake"}, -- T
	{text = "Ϲ", data = "pumpkin"},
	{text = "Ϲϱ", data = "pumpkincookie"},
	{text = "߹", data = "ratatouille"},
	{text = "칽ͷ", data = "red_cap"},
	{text = "", data = "berries_cooked"},
	{text = "ܲ", data = "carrot_cooked"},
	{text = "ʳ", data = "spoiled_food"},
	{text = "õĵ", data = "rottenegg"},
	{text = "", data = "seeds"},
	{text = "ӰԿ", data = "maxwellkey"},
	{text = "ʯƬ", data = "pomegranate_cooked"},
	{text = "Ѻ", data = "stuffedeggplant"},
	{text = "̫", data = "taffy"},
	{text = "", data = "tallbirdegg"},
	{text = "", data = "seeds_cooked"},
	{text = "", data = "turkeydinner"},
	{text = "", data = "waffles"},
	{text = "ʧܵ", data = "wetgoop"},
	{text = "ܲ", data = "carrot_seeds"},
	{text = "", data = "durian_seeds"},
	{text = "", data = "eggplant_seeds"},
	{text = "ʯ", data = "pomegranate_seeds"},
	{text = "Ϲ", data = "pumpkin_seeds"},
}

local objectOptions = {
	{text = "", data = "balloon"},-- O
	{text = "㽶", data = "cave_banana_tree"},-- O
	{text = "", data = "basalt_pillar"},
	{text = "", data = "basalt"},
	{text = "䳲", data = "beehive"},
	{text = "۷", data = "beemine"},
	{text = "ľ", data = "berrybush"},
	{text = "ľ 2", data = "berrybush2"},
	{text = "", data = "birdtrap"},
	{text = "ʬ", data = "houndbone"},
	{text = "Ӫ", data = "bonfire"},
	{text = "ʯͷ 1", data = "rock1"},
	{text = "ʯͷ 2", data = "rock2"},
	{text = "ʯͷ 3", data = "rock_flintless"}, 
	{text = "", data = "bunnyman"}, -- O
	{text = "", data = "rabbithouse"}, -- O
	{text = "סˮ", data = "cave_entrance"}, -- O
	{text = "ӫ⻨", data = "flower_cave"}, -- O
	{text = "ħȳ()", data = "diviningrodbase"},
	{text = "ħȳ()", data = "diviningrodstart"},
	{text = "չ", data = "evergreen_burnt"},
	{text = "", data = "evergreen_normal"},
	{text = "С", data = "evergreen_short"},
	{text = "׮", data = "evergreen_stump"},
	{text = "", data = "evergreen_tall"},
	{text = "ħ֮", data = "flower_evil"},
	{text = "Ұ", data = "cave_fern"},-- O
	{text = "ө", data = "fireflies"},
	{text = "", data = "flower"},
	{text = "", data = "grass"},
	{text = "Ĺ", data = "gravestone"},
	{text = "ֱ", data = "statueharp"},
	{text = "Ȯ", data = "houndmound"},
	{text = "ɱ˷䳲", data = "wasphive"},
	{text = "׳", data = "evergreen_sparse_normal"},
	{text = "׳С", data = "evergreen_sparse_short"},
	{text = "׳Ĵ", data = "evergreen_sparse_tall"},
	{text = "סά˹", data = "lockedwes"},
	{text = "", data = "lightning_rod"}, 
	{text = "ʯ", data = "marblepillar"},
	{text = "ʯ", data = "marbletree"},
	{text = "̹ľ", data = "marsh_bush"},
	{text = "ߵĲ", data = "marsh_plant"},
	{text = "", data = "marsh_tree"},
	{text = "˹Τ(END)", data = "maxwellendgame"},
	{text = "˹Τ", data = "statuemaxwell"},
	{text = "˹Τ()", data = "maxwellthrone"},
	{text = "˹Τ", data = "trap_teeth_maxwell"},
	{text = "˹Τ", data = "adventure_portal"},
	{text = "˹Τ(ʱЧ)", data = "maxwellhead"},
	{text = "˹Τ֮", data = "maxwelllight"},
	{text = "˹Τ", data = "maxwellphonograph"},
	{text = "", data = "resurrectionstatue"},
	{text = "ͷ", data = "mermhead"},
	{text = "˷", data = "mermhouse"},
	{text = "Ĺ(Ĺ)", data = "mound"},
	{text = "Ģ()", data = "mushtree_tall"}, -- O
	{text = "Ģ(е)", data = "mushtree_medium"}, -- O
	{text = "Ģ(С)", data = "mushtree_small"}, -- O
	{text = "Ģ", data = "blue_mushroom"},
	{text = "Ģ", data = "green_mushroom"},
	{text = "Ģ", data = "red_mushroom"},
	{text = "Ɱ(ֱ)", data = "sanityrock"},
	{text = "Ɱ()", data = "insanityrock"},
	{text = "ͷ", data = "pighead"},
	{text = "", data = "pighouse"},
	{text = "ͼ", data = "pigtorch"},
	{text = "ܲ()", data = "carrot_planted"},
	{text = "(ݵ)", data = "pond"},
	{text = "()", data = "pond_mos"},
	{text = "", data = "rabbithole"},
	{text = "", data = "rainometer"}, 
	{text = "«έ", data = "reeds"},
	{text = "ʯ", data = "resurrectionstone"}, 
	{text = "", data = "sapling"},
	{text = "޶涴", data = "wormhole_limited_1"},
	{text = "Ǽ", data = "skeleton"},
	{text = "֩볲", data = "spiderden"},
	{text = "ʯ()", data = "stalagmite"}, -- O
	{text = "ʯ()", data = "stalagmite_tall"},-- O
	{text = "Ѩ()", data = "tallbirdnest"},
	{text = "", data = "teleportato_base"},
	{text = "ͽ", data = "telebase"},-- O
	{text = "()", data = "teleportato_box"},
	{text = "(֧)", data = "teleportato_crank"},
	--{text = "Teleportato End", data = "teleportato_checkmate"}, --no longer works
	{text = "()", data = "teleportato_potato"},
	{text = "()", data = "teleportato_ring"},
	{text = "ʹ", data = "tentacle_garden"},-- O
	{text = "", data = "trap_teeth"},
	{text = "ʯ", data = "resurrectionstone"},
	{text = "ǽ", data = "wall_hay"},
	{text = "ʯǽ", data = "wall_stone"},
	{text = "ľǽ", data = "wall_wood"},
	{text = "Ѩ", data = "walrus_camp"},
	{text = "¶ȼ", data = "winterometer"}, 
	{text = "涴", data = "wormhole"},
}
local index_2_Options = {
	{text = "֮", data = "book_sleep"},-- M
	{text = "԰֮", data = "book_gardening"},-- M
	{text = "ĩ֮", data = "book_brimstone"},-- M
	{text = "֮", data = "book_birds"},-- M
	{text = "֮", data = "book_tentacles"},-- M
	{text = "ϱʯ", data = "purplegem"},-- M
	{text = "ʯ", data = "bluegem"},-- M
	{text = "챦ʯ", data = "redgem"},-- M
	{text = "ɫʯ", data = "orangegem"},--- M
	{text = "Ʊʯ", data = "yellowgem"},-- M
	{text = "̱ʯ", data = "greengem"},-- M
	{text = "", data = "icestaff"},-- M
	{text = "", data = "firestaff"},-- M
	{text = "ͷ", data = "telestaff"},-- M
	{text = "ɫ(δ)", data = "orangestaff"},-- M
	{text = "ɫ(δ)", data = "greenstaff"},-- M
	{text = "Ƿ", data = "yellowstaff"},-- M
}
-- Updates --
local spinnerFont = {font = text_font, size = 24} --30
local spinnerHeight = 48 --64

TestScreen = Class(Screen, function(self, displayed)
	Screen._ctor(self, "TestScreen")

	local graphicsOptions = TheFrontEnd:GetGraphicsOptions()

	self.options = {
		entityPrefab = nil,
		itemPrefab = nil,
		foodPrefab = nil,
		objectPrefab = nil,
		item_2_Prefab = nil,
	}

	local indexTable = {}

	indexTable = self:RetrieveIndices()

	self.entityIndex = indexTable[1] or 1
	self.itemIndex = indexTable[2] or 1
	self.foodIndex = indexTable[3] or 1
	self.speedIndex = indexTable[4] or 1
	self.objectIndex = indexTable[5] or 1
	self.item_2_Index = indexTable[6] or 1 -- magic --
	self.displayed = displayed
	self.working = deepcopy(self.options)

	self:DoInit()
	self:InitializeSpinners()
end)

function string.starts(String,Start)
	Start = string.upper(Start)
	return string.sub(String,1,string.len(Start)) == Start
end

function TestScreen:OnTextInput(text)
	local spinner = self:GetActiveFocusWidget()
	
	local index = 1

	for k,v in pairs(spinner.options) do
		if string.starts(v.text, text) then
			spinner:SetSelectedIndex(index)
			break
		end	
		
		index = index + 1
	end
end

function TestScreen:OnKeyUp(key)
	if key == KEY_ESCAPE then
		self:Close()
	end
end

function TestScreen:OnKeyDown(key)
	if (key == KEY_TAB) and not TheInput:IsKeyDown(KEY_ALT) then
		self:AdvanceFocus( not TheInput:IsKeyDown(KEY_SHIFT) )
	end
end

function TestScreen:Accept()
	self:Save(function()
	self:Close()
	end)
end

function TestScreen:Save(cb)
	self.options = deepcopy(self.working)
	Profile:Save(function()
	if cb then
	  cb()
	end
	end)
end

function TestScreen:Close()
	TheSim:SetSetting("TEST_TOOLS", "entityIndex", self.entitySpinner:GetSelectedIndex())
	TheSim:SetSetting("TEST_TOOLS", "itemIndex", self.itemSpinner:GetSelectedIndex())
	TheSim:SetSetting("TEST_TOOLS", "foodIndex", self.foodSpinner:GetSelectedIndex())
	TheSim:SetSetting("TEST_TOOLS", "speedIndex", self.speedSpinner:GetSelectedIndex())
	TheSim:SetSetting("TEST_TOOLS", "objectIndex", self.objectSpinner:GetSelectedIndex())
	TheSim:SetSetting("TEST_TOOLS", "item_2_Index", self.item_2_Spinner:GetSelectedIndex()) -- magic --

	TheFrontEnd:PopScreen(self)
	self.displayed = false
	SetHUDPause(false)
end

function TestScreen:RetrieveIndices()
	local values = {}

	table.insert(values, TheSim:GetSetting("TEST_TOOLS", "entityIndex") or 1)
	table.insert(values, TheSim:GetSetting("TEST_TOOLS", "itemIndex") or 1)
	table.insert(values, TheSim:GetSetting("TEST_TOOLS", "foodIndex") or 1)
	table.insert(values, TheSim:GetSetting("TEST_TOOLS", "speedIndex") or 1)
	table.insert(values, TheSim:GetSetting("TEST_TOOLS", "objectIndex") or 1)
	table.insert(values, TheSim:GetSetting("TEST_TOOLS", "item_2_Index") or 1) -- magic --

	return values
end

local MakeMenu = function(offset, menuitems)
	local menu = Widget("OptionsMenu")
	local pos = Vector3(0, 0, 0)
	
	for k, v in ipairs(menuitems) do
		local button = menu:AddChild(AnimButton("button"))
		button:SetPosition(pos)
		button:SetText(v.text)
		button.text:SetColour(0, 0, 0, 1)
		button:SetOnClick(v.cb)
		button:SetFont(BUTTONFONT)
		button:SetTextSize(40)
		pos = pos + offset
	end
	
	return menu
end

function TestScreen:AddSpinners(data, user_offset, bg_size)
	local master_group = self:AddChild(Widget("SpinnerGroup"))
	master_group:SetVAnchor(ANCHOR_TOP)
	master_group:SetHAnchor(ANCHOR_MIDDLE)
	
	local offset = {0, 0, 0}
	if user_offset then
		offset[1] = offset[1] + user_offset[1]
		offset[2] = offset[2] + user_offset[2]
		offset[3] = offset[3] + user_offset[3]
	end
	local centerV = -RESOLUTION_Y/4
	master_group:SetPosition(offset[1], offset[2] + centerV, offset[2]) --first offset = horizontal.  second offset is vertical
	
	local label_width = 200
	
	for idx, entry in ipairs(data) do
		local text = entry[1]
		local spinner = entry[2]
		local group = master_group:AddChild(Widget("SpinnerGroup"))
		group:SetPosition(0, (idx - 1) * -75 + 25, 0)
		local label = group:AddChild(Text(DEFAULTFONT, 30, text))
		label:SetPosition(0.5 * label_width, 0, 0)
		label:SetRegionSize(label_width, 50)
		label:SetHAlign(ANCHOR_RIGHT)
		group:AddChild(spinner)
		spinner:SetPosition(label_width + 32, 0, 0)
		spinner:SetWrapEnabled(true)
		spinner:SetLeftMouseDown(function() self:SetFocus(spinner) end)
	end
	
	return master_group
end

function TestScreen:DoInit()
	--below uses Klei's gray background with tint:
    self.bg = self:AddChild(Image("images/ui.xml", "bg_plain.tex"))
	self.bg:SetTint(BGCOLOURS.RED[1],BGCOLOURS.RED[2],BGCOLOURS.RED[3], 1)
    --self.bg = self:AddChild(Image("mods/Test Tools/scripts/images/bg_red.xml", "bg_red.tex"))
    self.bg:SetVRegPoint(ANCHOR_MIDDLE)
    self.bg:SetHRegPoint(ANCHOR_MIDDLE)
    self.bg:SetVAnchor(ANCHOR_MIDDLE)
    self.bg:SetHAnchor(ANCHOR_MIDDLE)
    self.bg:SetScaleMode(SCALEMODE_FILLSCREEN)
    
	self.root = self:AddChild(Widget("ROOT"))
    self.root:SetVAnchor(ANCHOR_MIDDLE)
    self.root:SetHAnchor(ANCHOR_MIDDLE)
    self.root:SetPosition(0,0,0)
    self.root:SetScaleMode(SCALEMODE_PROPORTIONAL)

	
	local menu_items = {
		{ text = "ȼ", cb = function() TheFrontEnd:PushScreen(KeyScreen({ {text="Back", cb = function() end}})) end },	
		{ text = "صϷ", cb = function() self:Accept() end }
	}
----- Menu buttons
	if self.menu then
		self.menu:Kill()
	end
	
	local menu_spacing = 60
	local bottom_offset = 70
	local this = self
----- Menu buttons
	self.itemSpinner = Spinner(uncraftableItemOptions, 180, spinnerHeight, spinnerFont, spinner_atlas, spinner_images)
	  function self.itemSpinner:OnChanged(data)
			this.working.itemPrefab = data
			this:UpdateSelectedItem()
			self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex"))
			self.image:SetScale(0.8,0.8,0.8)
			self.image:SetPosition(115,-75,0)
			self.image = self:AddChild(Image("images/inventoryimages.xml", data.. ".tex"))
			
			self.image:SetPosition(115,-75,0)
	  end

	self.foodSpinner = Spinner(foodItemOptions, 180, spinnerHeight, spinnerFont, spinner_atlas, spinner_images)
		function self.foodSpinner:OnChanged(data)
			this.working.foodPrefab = data
			this:UpdateSelectedFood()
			self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex"))
			self.image:SetScale(0.8,0.8,0.8)
			self.image:SetPosition(115,-75,0)
			self.image = self:AddChild(Image("images/inventoryimages.xml", data.. ".tex"))
			self.image:SetPosition(115,-75,0)
		end

-------- OBJECTS ------
	self.objectSpinner = Spinner(objectOptions, 180, spinnerHeight, spinnerFont, spinner_atlas, spinner_images)
		function self.objectSpinner:OnChanged(data)
			this.working.objectPrefab = data
			this:UpdateSelectedObject()
----------
self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex"))
self.image:SetScale(1,1,1) -- large portrait box
self.image:SetPosition(350,25,0)

local my_anim = self:AddChild(UIAnim(data))
my_anim:GetAnimState():SetBank(data)
my_anim:GetAnimState():SetBuild(data)
my_anim:GetAnimState():PlayAnimation("idle")
--if my_anim:GetAnimState():SetBank(data) then
my_anim:SetScale(0.15,0.15,0.15)
my_anim:SetPosition(350,-10,0)
--else
--self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex")) -- this can be customized to say "Image Not Available"
--end

end


---------- ENTITYS -------
		self.entitySpinner = Spinner(entityOptions, 180, spinnerHeight, spinnerFont, spinner_atlas, spinner_images)
	  function self.entitySpinner:OnChanged(data)
			this.working.entityPrefab = data
			this:UpdateSelectedEntity()
self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex"))
self.image:SetScale(1,1,1) -- large portrait box
self.image:SetPosition(350,-25,0)

local my_anim = self:AddChild(UIAnim(data))
my_anim:GetAnimState():SetBank(data)
my_anim:GetAnimState():SetBuild(data)
my_anim:GetAnimState():PlayAnimation("idle")
--if my_anim:GetAnimState():SetBank(data) then
my_anim:SetScale(0.25,0.25,0.25)
my_anim:SetPosition(350,-70,0)
--else
--self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex")) -- this can be customized to say "Image Not Available"
--end
	  end
-- magic --
		self.item_2_Spinner = Spinner(index_2_Options, 180, spinnerHeight, spinnerFont, spinner_atlas, spinner_images)
		function self.item_2_Spinner:OnChanged(data)
			this.working.item_2_Prefab = data
			this:UpdateSelected_2_Index()
			self.image = self:AddChild(Image("images/ui.xml", "portrait_bg.tex"))
			self.image:SetScale(0.8,0.8,0.8)
			self.image:SetPosition(115,-75,0)
			self.image = self:AddChild(Image("images/inventoryimages.xml", data.. ".tex"))
			self.image:SetPosition(115,-75,0)
		end
-- magic --
	self.speedSpinner = NumericSpinner( 2, 10, 50, spinnerHeight, spinnerFont, spinner_atlas, spinner_images )
	self.speedSpinner.OnChanged =
		function( self, data )
			this:UpdateSpeedMultiplier()
		end 
		
	self.godmodeSpinner = Spinner(enableDisableOptions, 50, spinnerHeight, spinnerFont, spinner_atlas, spinner_images)
		function self.godmodeSpinner:OnChanged(data)
			this:UpdateGodMode()
		end

	local spawning_spinners = {}
	local option_spinners = {}
	local toggle_spinners = {}

	local spawn_pos, option_pos, toggle_pos, bg_pos, bg_size

	table.insert(spawning_spinners, { ":(Ctrl-X)", self.itemSpinner })
	table.insert(spawning_spinners, { "", self.godmodeSpinner }) --makes a blank line
	table.insert(spawning_spinners, { "ʳ:(Ctrl-T)", self.foodSpinner })
	table.insert(spawning_spinners, { "", self.godmodeSpinner }) --makes a blank line
	table.insert(spawning_spinners, { "ͼλ:(Shift-O)", self.objectSpinner })
	table.insert(spawning_spinners, { ":(Shift-Z)", self.entitySpinner })
	
	table.insert(spawning_spinners, { "ϵģʽ:", self.godmodeSpinner })
	table.insert(spawning_spinners, { ":", self.speedSpinner })
	table.insert(toggle_spinners, { "ħ:(Alt-L)", self.item_2_Spinner }) -- magic --
	
	local centerH = -RESOLUTION_X/2.5 -- Horizontal position of 'prefab' column
	local centerO = RESOLUTION_X/15 -- Horizontal position of 'toggle' column
	print (centerH)
	print (centerO)
	spawn_pos = {centerH, 75, 0} --Vertical position of all prefab items table
	toggle_pos = {centerO,75,0} --Vertical postion of all 'toggle' items (right side)
	bg_pos = {640, 360,0}
	bg_size = {1000, 700}


	local spawn_group = self:AddSpinners(spawning_spinners, spawn_pos)
	local option_group = self:AddSpinners(option_spinners, option_pos)
	local toggle_group = self:AddSpinners(toggle_spinners, toggle_pos)
	
	self:PushFocusWidget(self.entitySpinner)
	self:PushFocusWidget(self.itemSpinner)
	self:PushFocusWidget(self.foodSpinner)
	self:PushFocusWidget(self.objectSpinner)
	self:PushFocusWidget(self.item_2_Spinner)-- magic --

	self.soundmenu = self:AddChild(MakeMenu(Vector3(0, -menu_spacing, 0), menu_items))
--Keys and Close button placement:
	self.soundmenu:SetHAnchor(ANCHOR_RIGHT)
	self.soundmenu:SetPosition(-120, bottom_offset + menu_spacing * (#menu_items - 1), 0)
end

local EnabledOptionsIndex = function(enabled)
	if enabled then
		return 2
	else
		return 1
	end
end

local function GodModeIndex()
	if GetPlayer().components.health:IsInvincible() then
		return 2
	else
		return 1
	end
end

function TestScreen:UpdateSelectedEntity()
	if self.entitySpinner:GetSelected().data then
		GetPlayer().components.testtoolcontroller.entityPrefab = self.entitySpinner:GetSelectedData()
	end
end

function TestScreen:UpdateSelectedItem()
	if self.itemSpinner:GetSelected().data then
		GetPlayer().components.testtoolcontroller.itemPrefab = self.itemSpinner:GetSelectedData()
	end
end

function TestScreen:UpdateSelectedFood()
	if self.foodSpinner:GetSelected().data then
		GetPlayer().components.testtoolcontroller.foodPrefab = self.foodSpinner:GetSelectedData()
	end
end

function TestScreen:UpdateSelectedObject()
	if self.objectSpinner:GetSelected().data then
		GetPlayer().components.testtoolcontroller.objectPrefab = self.objectSpinner:GetSelectedData()
	end
end
-- magic --
function TestScreen:UpdateSelected_2_Index()
	if self.item_2_Spinner:GetSelected().data then
		GetPlayer().components.testtoolcontroller.item_2_Prefab = self.item_2_Spinner:GetSelectedData()
		end
end
-- magic --
function TestScreen:UpdateSpeedMultiplier()
	if self.speedSpinner:GetSelected() then
		GetPlayer().components.testtoolcontroller.speed_multiplier = self.speedSpinner:GetSelectedData()
	end
end

function TestScreen:UpdateGodMode()
	if self.godmodeSpinner:GetSelected() then
		local value = self.godmodeSpinner:GetSelectedData()
		GetPlayer().components.health:SetInvincible(value)
	end
end

----------------------------------------------------------------------
function TestScreen:InitializeSpinners()
	self.entitySpinner:SetSelectedIndex(self.entityIndex)
	self:UpdateSelectedEntity()

	self.itemSpinner:SetSelectedIndex(self.itemIndex)
	self:UpdateSelectedItem()

	self.foodSpinner:SetSelectedIndex(self.foodIndex)
	self:UpdateSelectedFood()

	self.objectSpinner:SetSelectedIndex(self.objectIndex)
	self:UpdateSelectedObject()
-- magic --
	self.item_2_Spinner:SetSelectedIndex(self.item_2_Index)
	self:UpdateSelected_2_Index()
-- magic --	
	self.speedSpinner:SetSelectedIndex(self.speedIndex)
	self:UpdateSpeedMultiplier()

	self.godmodeSpinner:SetSelectedIndex(GodModeIndex())
	self:UpdateGodMode()
end
